javax.ws.rs.ext

## Interface MessageBodyWriter<T>

- Type Parameters:
    `T` - the type that can be written.
  All Known Implementing Classes:
    AbstractEntityProvider, AbstractJAXBProvider, AtomEntryProvider, AtomFeedProvider, ByteArrayProvider, CollectionProvider, DataSourceProvider, DefaultTextPlain, DocumentProvider, EnvelopedWriter, FastInfosetCollectionProvider, FastinfoSetElementProvider, FastInfosetMapProvider, FastinfoSetXmlRootElementProvider, FastinfoSetXmlSeeAlsoProvider, FastinfoSetXmlTypeProvider, FileProvider, FileRangeWriter, FormUrlEncodedProvider, HtmlRenderableWriter, IIOImageProvider, InputStreamProvider, com.fasterxml.jackson.jaxrs.json.JacksonJaxbJsonProvider, com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider, org.codehaus.jackson.jaxrs.JacksonJsonProvider, JAXBElementProvider, JAXBXmlRootElementProvider, JAXBXmlSeeAlsoProvider, JAXBXmlTypeProvider, JaxrsFormProvider, JettisonElementProvider, JettisonXmlRootElementProvider, JettisonXmlSeeAlsoProvider, JettisonXmlTypeProvider, JsonArrayProvider, JsonCollectionProvider, JsonMapProvider, JsonObjectProvider, JsonStructureProvider, ListMultipartWriter, MapMultipartFormDataWriter, MapProvider, MimeMultipartProvider, MultipartFormAnnotationWriter, MultipartFormDataWriter, MultipartRelatedWriter, MultipartSignedWriter, MultipartWriter, PKCS7SignatureTextWriter, PKCS7SignatureWriter, com.fasterxml.jackson.jaxrs.base.ProviderBase, ReaderProvider, ResteasyJackson2Provider, ResteasyJacksonProvider, SerializableProvider, ServerFormUrlEncodedProvider, SourceProvider, StreamingOutputProvider, StringBeanEntityProvider, StringTextStar, XopWithMultipartRelatedJAXBProvider, XopWithMultipartRelatedWriter, YamlProvider

      public interface MessageBodyWriter<T>

  Contract for a provider that supports the conversion of a Java type to a stream. A `MessageBodyWriter` implementation may be annotated with `Produces` to restrict the media types for which it will be considered suitable.

  Providers implementing `MessageBodyWriter` contract must be either programmatically registered in a JAX-RS runtime or must be annotated with `@Provider` annotation to be automatically discovered by the JAX-RS runtime during a provider scanning phase.

  Since:
    1.0
  Author:
    Paul Sandoz, Marc Hadley
  See Also:
    `Provider`, `Produces`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `getSize(T t, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Originally, the method has been called before `writeTo` to ascertain the length in bytes of the serialized form of `t`.
    `boolean` | `isWriteable(Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyWriter supports a particular type.
    `void` | `writeTo(T t, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,Object> httpHeaders, OutputStream entityStream)` Write a type to an HTTP message.

- - ### Method Detail

    - #### isWriteable

          boolean isWriteable(Class<?> type,
                            Type genericType,
                            Annotation[] annotations,
                            MediaType mediaType)

      Ascertain if the MessageBodyWriter supports a particular type.
      Parameters:
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written, obtained either by reflection of a resource method return type or via inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
      Returns:
        `true` if the type is supported, otherwise `false`.

    - #### getSize

          long getSize(T t,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType)

      Originally, the method has been called before `writeTo` to ascertain the length in bytes of the serialized form of `t`. A non-negative return value has been used in a HTTP `Content-Length` header.

      As of JAX-RS 2.0, the method has been deprecated and the value returned by the method is ignored by a JAX-RS runtime. All `MessageBodyWriter` implementations are advised to return `-1` from the method. Responsibility to compute the actual `Content-Length` header value has been delegated to JAX-RS runtime.

      Parameters:
        `t` - the instance to write
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
      Returns:
        length in bytes or -1 if the length cannot be determined in advance.

    - #### writeTo

          void writeTo(T t,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType,
                     MultivaluedMap<String,Object> httpHeaders,
                     OutputStream entityStream)
                       throws IOException,
                              WebApplicationException

      Write a type to an HTTP message. The message header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the message body.
      Parameters:
        `t` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - a mutable map of the HTTP message headers.
        `entityStream` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
      Throws:
        `IOException` - if an IO error arises.
        `WebApplicationException` - if a specific HTTP error response needs to be produced. Only effective if thrown prior to the message being committed.

Copyright © 2014. All Rights Reserved.